///////////////////////////////////////////////////////////////
// オーバルコースを走行するＤＭＣ（Direct Motor Car）
//                               2012/07/12 (Thi) T.Shirai
// http://rgns1.life.chukyo-u.ac.jp/RobotGrandPrix/index.html
///////////////////////////////////////////////////////////////

// 動作に関わるオプションを指定して下さい．
void Options() {
  crowbar.nonStop();
}

void initCrowbar() {
  crow = startCrowbar.generate(70, 25, 2);
}
crowbarClass crow;

void Setup() {
  // オーバルコース
  crow.createView("Oval").setViewBgColor(#eeeeee).clrView();
//  crow.cv.setEllipseMode(RADIUS).setStroke(#ffffff).setFill(#ffffff);
  // テキスト情報
  crow.splitViewV("Text", 0.45).setViewBgColor(#ffffff).clrView();
  crow.cv.prepareFont().setTextSize(14);
  // ＤＭＣ中心視点
  crow.splitViewH("DMC", 0.6).setViewBgColor(#eeeeee).setViewPivotCenter().clrView();
  // ワールド座標の設定
  crow.getView("Oval").world(0.0, 0.0, 12200.0, 2000.0).worldOrigin();
  crow.getView("DMC").worldY(-200.0, 200.0).worldOrigin();
  // 軌跡表示用の透明なビューポートの作成
  crow.cloneView("Oval", "Trajectory").setTransparentView(true);
}

class dmcClass {
  float   x, y;    // 中心座標
  float   angle;   // 角度
  float   v;       // 速度 [mm/s]
  float   dt;      // 時間刻み
  float   time;    // 経過時間
  boolean rotate;  // 回転表示
  // 外見
  float   DMC_RADIUS   = 100.0;
  float   MOTOR_RADIUS = 10.0;
  float   EYE_RADIUS   = DMC_RADIUS * 0.6;
  boolean transparent;

  dmcClass() {
    reset();
  }
  void reset() {
    x      = -3000.0 - 40.0 - DMC_RADIUS;
    y      = -500.0;
    angle  = 0.0;
    v      = 100.0;
    dt     = 1.0 / 10.0;
    time   = 0.0;
    rotate = false;
    transparent = false;
  }
  void recalc() {
    x += v * dt * cos(radians(angle));
    y += v * dt * sin(radians(angle));
    time += dt;
  }
}
dmcClass DMC = new dmcClass();

// メインルーチン
// ユーザのメインのプログラム（１度しか実行されない）を以下に記述
void Main() {
  DMC.reset();
  crow.view("Trajectory").moveTo(DMC.x, DMC.y).setStroke(#ff0000);
  crow.clrscr();
}

